/**
 * Provides data for double value change events.
*/
export class IgrDoubleValueChangedEventArgs {
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the value before the change.
    */
    get oldValue() {
        return this.i.oldValue;
    }
    set oldValue(v) {
        this.i.oldValue = +v;
    }
    /**
     * Gets the new value.
    */
    get newValue() {
        return this.i.newValue;
    }
    set newValue(v) {
        this.i.newValue = +v;
    }
}
