import { IgrCaptureImageSettings } from "./igr-capture-image-settings";
var IgrImageCapturedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrImageCapturedEventArgs() {
        this.mounted = false;
    }
    Object.defineProperty(IgrImageCapturedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageCapturedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrImageCapturedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrImageCapturedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrImageCapturedEventArgs.prototype, "base64Data", {
        /**
         * Gets the captured image as Base64.
        */
        get: function () {
            return this.i.base64Data;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageCapturedEventArgs.prototype, "image", {
        /**
         * Gets the captured image.
        */
        get: function () {
            return this.i.image;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageCapturedEventArgs.prototype, "settings", {
        /**
         * Gets the settings used to capture the image.
        */
        get: function () {
            var r = this.i.settings;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrCaptureImageSettings();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        enumerable: false,
        configurable: true
    });
    return IgrImageCapturedEventArgs;
}());
export { IgrImageCapturedEventArgs };
