import { Type } from "./type";
/**
 * Describes type of data columns to use for the data legend.
 */
export declare enum DataLegendSeriesFamily {
    /**
     * Specifies the Category series
     */
    Category = 0,
    /**
     * Specifies the Range series
     */
    Range = 1,
    /**
     * Specifies the Financial Price series
     */
    Financial = 2,
    /**
     * Specifies the Financial Indicator series
     */
    Indicator = 3,
    /**
     * Specifies the Polar series
     */
    Polar = 4,
    /**
     * Specifies the Radial series
     */
    Radial = 5,
    /**
     * Specifies the Scatter series
     */
    Scatter = 6,
    /**
     * Specifies the Stacked series
     */
    Stacked = 7,
    /**
     * Specifies the Shape series
     */
    Shape = 8,
    /**
     * Specifies the Geographic series
     */
    Geographic = 9,
    /**
     * Specifies the Highlight series
     */
    Highlight = 10
}
/**
 * @hidden
 */
export declare let DataLegendSeriesFamily_$type: Type;
