import { Description } from "./Description";
import { WebDataCloneStrategyDescription } from "./WebDataCloneStrategyDescription";
import { WebClipboardOptionsDescription } from "./WebClipboardOptionsDescription";
import { WebColumnDescription } from "./WebColumnDescription";
import { WebActionStripDescription } from "./WebActionStripDescription";
import { WebPaginatorDescription } from "./WebPaginatorDescription";
import { WebGridResourceStringsDescription } from "./WebGridResourceStringsDescription";
import { WebFilteringExpressionsTreeDescription } from "./WebFilteringExpressionsTreeDescription";
import { WebPinningConfigDescription } from "./WebPinningConfigDescription";
import { WebFilteringStrategyDescription } from "./WebFilteringStrategyDescription";
import { WebGridSortingStrategyDescription } from "./WebGridSortingStrategyDescription";
import { WebSortingOptionsDescription } from "./WebSortingOptionsDescription";
import { WebSortingExpressionDescription } from "./WebSortingExpressionDescription";
import { WebOverlayOutletDirectiveDescription } from "./WebOverlayOutletDirectiveDescription";
import { WebGridStateDescription } from "./WebGridStateDescription";
import { Type } from "./type";
import { WebGridToolbarContentDescription } from "./WebGridToolbarContentDescription";
/**
 * @hidden
 */
export declare abstract class WebGridBaseDirectiveDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    get type(): string;
    constructor();
    private bg;
    get snackbarDisplayTime(): number;
    set snackbarDisplayTime(a: number);
    private at;
    get autoGenerate(): boolean;
    set autoGenerate(a: boolean);
    private j;
    get autoGenerateExclude(): string[];
    set autoGenerateExclude(a: string[]);
    private ax;
    get moving(): boolean;
    set moving(a: boolean);
    private ch;
    get emptyGridTemplateRef(): string;
    set emptyGridTemplateRef(a: string);
    private bo;
    get addRowEmptyTemplateRef(): string;
    set addRowEmptyTemplateRef(a: string);
    private cw;
    get loadingGridTemplateRef(): string;
    set loadingGridTemplateRef(a: string);
    private bh;
    get summaryRowHeight(): number;
    set summaryRowHeight(a: number);
    private z;
    get dataCloneStrategy(): WebDataCloneStrategyDescription;
    set dataCloneStrategy(a: WebDataCloneStrategyDescription);
    private x;
    get clipboardOptions(): WebClipboardOptionsDescription;
    set clipboardOptions(a: WebClipboardOptionsDescription);
    private c5;
    get rowClassesRef(): string;
    set rowClassesRef(a: string);
    private dp;
    get rowStylesRef(): string;
    set rowStylesRef(a: string);
    private cz;
    get primaryKey(): string;
    set primaryKey(a: string);
    private k;
    get columnList(): WebColumnDescription[];
    set columnList(a: WebColumnDescription[]);
    private h;
    get actionStripComponents(): WebActionStripDescription[];
    set actionStripComponents(a: WebActionStripDescription[]);
    private cd;
    get dragGhostCustomTemplateRef(): string;
    set dragGhostCustomTemplateRef(a: string);
    private dh;
    get rowEditTextTemplateRef(): string;
    set rowEditTextTemplateRef(a: string);
    private c4;
    get rowAddTextTemplateRef(): string;
    set rowAddTextTemplateRef(a: string);
    private dd;
    get rowEditActionsTemplateRef(): string;
    set rowEditActionsTemplateRef(a: string);
    private di;
    get rowExpandedIndicatorTemplateRef(): string;
    set rowExpandedIndicatorTemplateRef(a: string);
    private c7;
    get rowCollapsedIndicatorTemplateRef(): string;
    set rowCollapsedIndicatorTemplateRef(a: string);
    private ct;
    get headerExpandedIndicatorTemplateRef(): string;
    set headerExpandedIndicatorTemplateRef(a: string);
    private cs;
    get headerCollapsedIndicatorTemplateRef(): string;
    set headerCollapsedIndicatorTemplateRef(a: string);
    private ci;
    get excelStyleHeaderIconTemplateRef(): string;
    set excelStyleHeaderIconTemplateRef(a: string);
    private dt;
    get sortAscendingHeaderIconTemplateRef(): string;
    set sortAscendingHeaderIconTemplateRef(a: string);
    private du;
    get sortDescendingHeaderIconTemplateRef(): string;
    set sortDescendingHeaderIconTemplateRef(a: string);
    private dv;
    get sortHeaderIconTemplateRef(): string;
    set sortHeaderIconTemplateRef(a: string);
    private o;
    get toolbar(): WebGridToolbarDescription[];
    set toolbar(a: WebGridToolbarDescription[]);
    private l;
    get paginationComponents(): WebPaginatorDescription[];
    set paginationComponents(a: WebPaginatorDescription[]);
    private ah;
    get resourceStrings(): WebGridResourceStringsDescription;
    set resourceStrings(a: WebGridResourceStringsDescription);
    private cm;
    get filteringLogic(): string;
    set filteringLogic(a: string);
    private ac;
    get filteringExpressionsTree(): WebFilteringExpressionsTreeDescription;
    set filteringExpressionsTree(a: WebFilteringExpressionsTreeDescription);
    private ab;
    get advancedFilteringExpressionsTree(): WebFilteringExpressionsTreeDescription;
    set advancedFilteringExpressionsTree(a: WebFilteringExpressionsTreeDescription);
    private cx;
    get locale(): string;
    set locale(a: string);
    private cy;
    get pagingMode(): string;
    set pagingMode(a: string);
    private av;
    get hideRowSelectors(): boolean;
    set hideRowSelectors(a: boolean);
    private ay;
    get rowDraggable(): boolean;
    set rowDraggable(a: boolean);
    private d3;
    get validationTrigger(): string;
    set validationTrigger(a: string);
    private az;
    get rowEditable(): boolean;
    set rowEditable(a: boolean);
    private cv;
    get height(): string;
    set height(a: string);
    private d4;
    get width(): string;
    set width(a: string);
    private bf;
    get rowHeight(): number;
    set rowHeight(a: number);
    private b8;
    get columnWidth(): string;
    set columnWidth(a: string);
    private cg;
    get emptyGridMessage(): string;
    set emptyGridMessage(a: string);
    private aw;
    get isLoading(): boolean;
    set isLoading(a: boolean);
    private a1;
    get shouldGenerate(): boolean;
    set shouldGenerate(a: boolean);
    private cf;
    get emptyFilteredGridMessage(): string;
    set emptyFilteredGridMessage(a: string);
    private an;
    get pinning(): WebPinningConfigDescription;
    set pinning(a: WebPinningConfigDescription);
    private as;
    get allowFiltering(): boolean;
    set allowFiltering(a: boolean);
    private ar;
    get allowAdvancedFiltering(): boolean;
    set allowAdvancedFiltering(a: boolean);
    private cn;
    get filterMode(): string;
    set filterMode(a: string);
    private d0;
    get summaryPosition(): string;
    set summaryPosition(a: string);
    private dz;
    get summaryCalculationMode(): string;
    set summaryCalculationMode(a: string);
    private a2;
    get showSummaryOnCollapse(): boolean;
    set showSummaryOnCollapse(a: boolean);
    private af;
    get filterStrategy(): WebFilteringStrategyDescription;
    set filterStrategy(a: WebFilteringStrategyDescription);
    private aj;
    get sortStrategy(): WebGridSortingStrategyDescription;
    set sortStrategy(a: WebGridSortingStrategyDescription);
    private ap;
    get sortingOptions(): WebSortingOptionsDescription;
    set sortingOptions(a: WebSortingOptionsDescription);
    private ds;
    get selectedRowsRef(): string;
    set selectedRowsRef(a: string);
    private cu;
    get headSelectorTemplateRef(): string;
    set headSelectorTemplateRef(a: string);
    private dn;
    get rowSelectorTemplateRef(): string;
    set rowSelectorTemplateRef(a: string);
    private ce;
    get dragIndicatorIconTemplateRef(): string;
    set dragIndicatorIconTemplateRef(a: string);
    private m;
    get sortingExpressions(): WebSortingExpressionDescription[];
    set sortingExpressions(a: WebSortingExpressionDescription[]);
    private au;
    get batchEditing(): boolean;
    set batchEditing(a: boolean);
    private bv;
    get cellSelection(): string;
    set cellSelection(a: string);
    private dl;
    get rowSelection(): string;
    set rowSelection(a: string);
    private b4;
    get columnSelection(): string;
    set columnSelection(a: string);
    private al;
    get outlet(): WebOverlayOutletDirectiveDescription;
    set outlet(a: WebOverlayOutletDirectiveDescription);
    private bi;
    get totalRecords(): number;
    set totalRecords(a: number);
    private a0;
    get selectRowOnClick(): boolean;
    set selectRowOnClick(a: boolean);
    private i;
    get actualColumnList(): WebColumnDescription[];
    set actualColumnList(a: WebColumnDescription[]);
    private n;
    get stateComponents(): WebGridStateDescription[];
    set stateComponents(a: WebGridStateDescription[]);
    private cl;
    get filteringExpressionsTreeChangeRef(): string;
    set filteringExpressionsTreeChangeRef(a: string);
    private bp;
    get advancedFilteringExpressionsTreeChangeRef(): string;
    set advancedFilteringExpressionsTreeChangeRef(a: string);
    private cr;
    get gridScrollRef(): string;
    set gridScrollRef(a: string);
    private bq;
    get cellClickRef(): string;
    set cellClickRef(a: string);
    private c6;
    get rowClickRef(): string;
    set rowClickRef(a: string);
    private co;
    get formGroupCreatedRef(): string;
    set formGroupCreatedRef(a: string);
    private d2;
    get validationStatusChangeRef(): string;
    set validationStatusChangeRef(a: string);
    private dr;
    get selectedRef(): string;
    set selectedRef(a: string);
    private dm;
    get rowSelectionChangingRef(): string;
    set rowSelectionChangingRef(a: string);
    private b5;
    get columnSelectionChangingRef(): string;
    set columnSelectionChangingRef(a: string);
    private b0;
    get columnPinRef(): string;
    set columnPinRef(a: string);
    private b1;
    get columnPinnedRef(): string;
    set columnPinnedRef(a: string);
    private bt;
    get cellEditEnterRef(): string;
    set cellEditEnterRef(a: string);
    private bu;
    get cellEditExitRef(): string;
    set cellEditExitRef(a: string);
    private br;
    get cellEditRef(): string;
    set cellEditRef(a: string);
    private bs;
    get cellEditDoneRef(): string;
    set cellEditDoneRef(a: string);
    private df;
    get rowEditEnterRef(): string;
    set rowEditEnterRef(a: string);
    private dc;
    get rowEditRef(): string;
    set rowEditRef(a: string);
    private de;
    get rowEditDoneRef(): string;
    set rowEditDoneRef(a: string);
    private dg;
    get rowEditExitRef(): string;
    set rowEditExitRef(a: string);
    private bw;
    get columnInitRef(): string;
    set columnInitRef(a: string);
    private b3;
    get columnsAutogeneratedRef(): string;
    set columnsAutogeneratedRef(a: string);
    private dw;
    get sortingRef(): string;
    set sortingRef(a: string);
    private dx;
    get sortingDoneRef(): string;
    set sortingDoneRef(a: string);
    private cj;
    get filteringRef(): string;
    set filteringRef(a: string);
    private ck;
    get filteringDoneRef(): string;
    set filteringDoneRef(a: string);
    private c3;
    get rowAddedRef(): string;
    set rowAddedRef(a: string);
    private c9;
    get rowDeletedRef(): string;
    set rowDeletedRef(a: string);
    private c8;
    get rowDeleteRef(): string;
    set rowDeleteRef(a: string);
    private c2;
    get rowAddRef(): string;
    set rowAddRef(a: string);
    private b2;
    get columnResizedRef(): string;
    set columnResizedRef(a: string);
    private b9;
    get contextMenuRef(): string;
    set contextMenuRef(a: string);
    private cc;
    get doubleClickRef(): string;
    set doubleClickRef(a: string);
    private b7;
    get columnVisibilityChangingRef(): string;
    set columnVisibilityChangingRef(a: string);
    private b6;
    get columnVisibilityChangedRef(): string;
    set columnVisibilityChangedRef(a: string);
    private bz;
    get columnMovingStartRef(): string;
    set columnMovingStartRef(a: string);
    private bx;
    get columnMovingRef(): string;
    set columnMovingRef(a: string);
    private by;
    get columnMovingEndRef(): string;
    set columnMovingEndRef(a: string);
    private cq;
    get gridKeydownRef(): string;
    set gridKeydownRef(a: string);
    private db;
    get rowDragStartRef(): string;
    set rowDragStartRef(a: string);
    private da;
    get rowDragEndRef(): string;
    set rowDragEndRef(a: string);
    private cp;
    get gridCopyRef(): string;
    set gridCopyRef(a: string);
    private dq;
    get rowToggleRef(): string;
    set rowToggleRef(a: string);
    private dk;
    get rowPinningRef(): string;
    set rowPinningRef(a: string);
    private dj;
    get rowPinnedRef(): string;
    set rowPinnedRef(a: string);
    private bn;
    get activeNodeChangeRef(): string;
    set activeNodeChangeRef(a: string);
    private dy;
    get sortingExpressionsChangeRef(): string;
    set sortingExpressionsChangeRef(a: string);
    private d1;
    get toolbarExportingRef(): string;
    set toolbarExportingRef(a: string);
    private c0;
    get rangeSelectedRef(): string;
    set rangeSelectedRef(a: string);
    private c1;
    get renderedRef(): string;
    set renderedRef(a: string);
    private cb;
    get dataChangingRef(): string;
    set dataChangingRef(a: string);
    private ca;
    get dataChangedRef(): string;
    set dataChangedRef(a: string);
}
/**
 * @hidden
 */
export declare class WebGridToolbarDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    get type(): string;
    constructor();
    private l;
    get showProgress(): boolean;
    set showProgress(a: boolean);
    private j;
    get grid(): WebGridBaseDirectiveDescription;
    set grid(a: WebGridBaseDirectiveDescription);
    private n;
    get name(): string;
    set name(a: string);
    private h;
    get tools(): WebGridToolbarContentDescription[];
    set tools(a: WebGridToolbarContentDescription[]);
}
