import { IgrDataLegendSeriesValueInfo } from "./igr-data-legend-series-value-info";
import { DataLegendSeriesValueType } from "./DataLegendSeriesValueType";
import { DataLegendSeriesContext as DataLegendSeriesContext_internal } from "./DataLegendSeriesContext";
import { ContentChildrenManager } from "./ContentChildrenManager";
/**
 * Represent info about series values
*/
export declare class IgrDataLegendSeriesContext {
    protected createImplementation(): DataLegendSeriesContext_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): DataLegendSeriesContext_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets a family of series that the current series belongs to, e.g. Category, Range, Financial, etc.
    */
    get seriesFamily(): string;
    set seriesFamily(v: string);
    findByName(name: string): any;
    /**
     * Creates an instance of DataLegendSeriesContext
    
    */
    getSeriesValueInfo(type: DataLegendSeriesValueType): IgrDataLegendSeriesValueInfo;
    /**
     * Gets value info for the series value type
    
    */
    getSeriesValue(type: DataLegendSeriesValueType): number;
    setSeriesValue(type: DataLegendSeriesValueType, value: number): void;
    setSeriesValueInfo(type: DataLegendSeriesValueType, valueInfo: IgrDataLegendSeriesValueInfo): void;
    /**
     * Gets all values that a series renders at the current data point
     * For example, Open, High, Low, Close for Financial Series
    
    */
    getSeriesValues(): number[];
}
