import { IDataSourceSchema } from "./IDataSourceSchema";
import { DataSourceDataProviderSchemaChangedEventArgs as DataSourceDataProviderSchemaChangedEventArgs_internal } from "./DataSourceDataProviderSchemaChangedEventArgs";
import { ContentChildrenManager } from "./ContentChildrenManager";
/**
 * Provides information about a schema change event.
*/
export declare class IgrDataSourceDataProviderSchemaChangedEventArgs {
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): DataSourceDataProviderSchemaChangedEventArgs_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Represents the current schema for the data provider.
    */
    get schema(): IDataSourceSchema;
    /**
     * Represents the current full count for the data provider. May be -1 if this information is not available yet.
    */
    get count(): number;
}
